class RequestAdapter {
  static isJson (str) {
    return this.safeParse(str) !== null
  }
  // static validRequest (obj) {
  //   return this.jsonRpcNotification(obj)
  // }
  static jsonRpcMessage (str) {
    let obj = this.safeParse(str)
    return (obj && obj.jsonrpc && (obj.jsonrpc === '2.0'))
  }
  static jsonRpcNotification (str) {
    let obj = this.safeParse(str)
    return (obj && !obj.id && obj.method && obj.params &&
      obj.jsonrpc && (obj.jsonrpc === '2.0'))
  }
  static ping (str) {
    let obj = this.safeParse(str)
    return obj && (obj.method === 'ping')
  }
  static whoAmI (str) {
    let obj = this.safeParse(str)
    return obj && (obj.method === 'whoami')
  }
  static auth (str) {
    let obj = this.safeParse(str)
    return obj && obj.params && obj.params.token &&
      obj.params.version && (obj.params.version === '1.0')
  }
  static iceCandidate (str) {
    let obj = this.safeParse(str)
    return obj && (obj.id === 'iceCandidate')
  }
  static sdpOffer (str) {
    let obj = this.safeParse(str)
    return obj && (obj.id === 'sdpOffer')
  }
  static protectedMethod (str) {
    let obj = this.safeParse(str)
    return obj && (obj.method === 'protected')
  }
  static invalidCallOrder (str) {
    let obj = this.safeParse(str)
    return obj && (obj.method === 'InvalidCallOrder')
  }
  static invalidMethodParameter (str) {
    let obj = this.safeParse(str)
    return obj && (obj.method === 'invalidMethodParameter')
  }
  static disconnect (str) {
    let obj = this.safeParse(str)
    return obj && (obj.method === 'disconnect')
  }
  static safeParse (str) {
    try {
      const obj = JSON.parse(str)
      if (obj && typeof obj === 'object' && obj !== null) {
        return obj
      }
    } catch (err) {}
    return null
  }
}

module.exports = RequestAdapter
